18658: ensure custom SSL certs are copied to the correct host dir
[arvados.git] / tools / salt-install / provision.sh
1 #!/bin/bash
2
3 # Copyright (C) The Arvados Authors. All rights reserved.
4 #
5 # SPDX-License-Identifier: CC-BY-SA-3.0
6
7 # If you want to test arvados in a single host, you can run this script, which
8 # will install it using salt masterless
9 # This script is run by the Vagrant file when you run it with
10 #
11 # vagrant up
12
13 set -o pipefail
14
15 # capture the directory that the script is running from
16 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null 2>&1 && pwd )"
17
18 usage() {
19   echo >&2
20   echo >&2 "Usage: ${0} [-h] [-h]"
21   echo >&2
22   echo >&2 "${0} options:"
23   echo >&2 "  -d, --debug                                 Run salt installation in debug mode"
24   echo >&2 "  -c <local.params>, --config <local.params>  Path to the local.params config file"
25   echo >&2 "  -t, --test                                  Test installation running a CWL workflow"
26   echo >&2 "  -r, --roles                                 List of Arvados roles to apply to the host, comma separated"
27   echo >&2 "                                              Possible values are:"
28   echo >&2 "                                                api"
29   echo >&2 "                                                controller"
30   echo >&2 "                                                dispatcher"
31   echo >&2 "                                                keepproxy"
32   echo >&2 "                                                keepstore"
33   echo >&2 "                                                keepweb"
34   echo >&2 "                                                shell"
35   echo >&2 "                                                webshell"
36   echo >&2 "                                                websocket"
37   echo >&2 "                                                workbench"
38   echo >&2 "                                                workbench2"
39   echo >&2 "                                              Defaults to applying them all"
40   echo >&2 "  -h, --help                                  Display this help and exit"
41   echo >&2 "  --dump-config <dest_dir>                    Dumps the pillars and states to a directory"
42   echo >&2 "                                              This parameter does not perform any installation at all. It's"
43   echo >&2 "                                              intended to give you a parsed sot of configuration files so"
44   echo >&2 "                                              you can inspect them or use them in you Saltstack infrastructure."
45   echo >&2 "                                              It"
46   echo >&2 "                                                - parses the pillar and states templates,"
47   echo >&2 "                                                - downloads the helper formulas with their desired versions,"
48   echo >&2 "                                                - prepares the 'top.sls' files both for pillars and states"
49   echo >&2 "                                                  for the selected role/s"
50   echo >&2 "                                                - writes the resulting files into <dest_dir>"
51   echo >&2 "  -v, --vagrant                               Run in vagrant and use the /vagrant shared dir"
52   echo >&2 "  --development                               Run in dev mode, using snakeoil certs"
53   echo >&2
54 }
55
56 arguments() {
57   # NOTE: This requires GNU getopt (part of the util-linux package on Debian-based distros).
58   if ! which getopt > /dev/null; then
59     echo >&2 "GNU getopt is required to run this script. Please install it and re-reun it"
60     exit 1
61   fi
62
63   TEMP=$(getopt -o c:dhp:r:tv \
64     --long config:,debug,development,dump-config:,help,roles:,test,vagrant \
65     -n "${0}" -- "${@}")
66
67   if [ ${?} != 0 ];
68     then echo "Please check the parameters you entered and re-run again"
69     exit 1
70   fi
71   # Note the quotes around `$TEMP': they are essential!
72   eval set -- "$TEMP"
73
74   while [ ${#} -ge 1 ]; do
75     case ${1} in
76       -c | --config)
77         CONFIG_FILE=${2}
78         shift 2
79         ;;
80       -d | --debug)
81         LOG_LEVEL="debug"
82         shift
83         set -x
84         ;;
85       --dump-config)
86         if [[ ${2} = /* ]]; then
87           DUMP_SALT_CONFIG_DIR=${2}
88         else
89           DUMP_SALT_CONFIG_DIR=${PWD}/${2}
90         fi
91         ## states
92         S_DIR="${DUMP_SALT_CONFIG_DIR}/salt"
93         ## formulas
94         F_DIR="${DUMP_SALT_CONFIG_DIR}/formulas"
95         ## pillars
96         P_DIR="${DUMP_SALT_CONFIG_DIR}/pillars"
97         ## tests
98         T_DIR="${DUMP_SALT_CONFIG_DIR}/tests"
99         DUMP_CONFIG="yes"
100         shift 2
101         ;;
102       --development)
103         DEV_MODE="yes"
104         shift 1
105         ;;
106       -r | --roles)
107         for i in ${2//,/ }
108           do
109             # Verify the role exists
110             if [[ ! "database,api,controller,keepstore,websocket,keepweb,workbench2,webshell,keepproxy,shell,workbench,dispatcher" == *"$i"* ]]; then
111               echo "The role '${i}' is not a valid role"
112               usage
113               exit 1
114             fi
115             ROLES="${ROLES} ${i}"
116           done
117           shift 2
118         ;;
119       -t | --test)
120         TEST="yes"
121         shift
122         ;;
123       -v | --vagrant)
124         VAGRANT="yes"
125         shift
126         ;;
127       --)
128         shift
129         break
130         ;;
131       *)
132         usage
133         exit 1
134         ;;
135     esac
136   done
137 }
138
139 copy_custom_cert() {
140   cert_dir=${1}
141   cert_name=${2}
142
143   mkdir -p /srv/salt/certs
144   cp -v ${cert_dir}/${cert_name}.crt /srv/salt/certs/arvados-${cert_name}.pem
145   cp -v ${cert_dir}/${cert_name}.key /srv/salt/certs/arvados-${cert_name}.key
146 }
147
148 DEV_MODE="no"
149 CONFIG_FILE="${SCRIPT_DIR}/local.params"
150 CONFIG_DIR="local_config_dir"
151 DUMP_CONFIG="no"
152 LOG_LEVEL="info"
153 CONTROLLER_EXT_SSL_PORT=443
154 TESTS_DIR="tests"
155
156 CLUSTER=""
157 DOMAIN=""
158
159 # Hostnames/IPs used for single-host deploys
160 HOSTNAME_EXT=""
161 HOSTNAME_INT="127.0.1.1"
162
163 # Initial user setup
164 INITIAL_USER=""
165 INITIAL_USER_EMAIL=""
166 INITIAL_USER_PASSWORD=""
167
168 CONTROLLER_EXT_SSL_PORT=8000
169 KEEP_EXT_SSL_PORT=25101
170 # Both for collections and downloads
171 KEEPWEB_EXT_SSL_PORT=9002
172 WEBSHELL_EXT_SSL_PORT=4202
173 WEBSOCKET_EXT_SSL_PORT=8002
174 WORKBENCH1_EXT_SSL_PORT=443
175 WORKBENCH2_EXT_SSL_PORT=3001
176
177 USE_LETSENCRYPT="no"
178 CUSTOM_CERTS_DIR="${SCRIPT_DIR}/certs"
179
180 ## These are ARVADOS-related parameters
181 # For a stable release, change RELEASE "production" and VERSION to the
182 # package version (including the iteration, e.g. X.Y.Z-1) of the
183 # release.
184 # The "local.params.example.*" files already set "RELEASE=production"
185 # to deploy  production-ready packages
186 RELEASE="development"
187 VERSION="latest"
188
189 # These are arvados-formula-related parameters
190 # An arvados-formula tag. For a stable release, this should be a
191 # branch name (e.g. X.Y-dev) or tag for the release.
192 # ARVADOS_TAG="2.2.0"
193 # BRANCH="main"
194
195 # Other formula versions we depend on
196 POSTGRES_TAG="v0.41.6"
197 NGINX_TAG="temp-fix-missing-statements-in-pillar"
198 DOCKER_TAG="v2.0.7"
199 LOCALE_TAG="v0.3.4"
200 LETSENCRYPT_TAG="v2.1.0"
201
202 # Salt's dir
203 DUMP_SALT_CONFIG_DIR=""
204 ## states
205 S_DIR="/srv/salt"
206 ## formulas
207 F_DIR="/srv/formulas"
208 ## pillars
209 P_DIR="/srv/pillars"
210 ## tests
211 T_DIR="/tmp/cluster_tests"
212
213 arguments ${@}
214
215 if [ -s ${CONFIG_FILE} ]; then
216   source ${CONFIG_FILE}
217 else
218   echo >&2 "You don't seem to have a config file with initial values."
219   echo >&2 "Please create a '${CONFIG_FILE}' file as described in"
220   echo >&2 "  * https://doc.arvados.org/install/salt-single-host.html#single_host, or"
221   echo >&2 "  * https://doc.arvados.org/install/salt-multi-host.html#multi_host_multi_hostnames"
222   exit 1
223 fi
224
225 if [ ! -d ${CONFIG_DIR} ]; then
226   echo >&2 "You don't seem to have a config directory with pillars and states."
227   echo >&2 "Please create a '${CONFIG_DIR}' directory (as configured in your '${CONFIG_FILE}'). Please see"
228   echo >&2 "  * https://doc.arvados.org/install/salt-single-host.html#single_host, or"
229   echo >&2 "  * https://doc.arvados.org/install/salt-multi-host.html#multi_host_multi_hostnames"
230   exit 1
231 fi
232
233 if grep -q 'fixme_or_this_wont_work' ${CONFIG_FILE} ; then
234   echo >&2 "The config file ${CONFIG_FILE} has some parameters that need to be modified."
235   echo >&2 "Please, fix them and re-run the provision script."
236   exit 1
237 fi
238
239 if ! grep -qE '^[[:alnum:]]{5}$' <<<${CLUSTER} ; then
240   echo >&2 "ERROR: <CLUSTER> must be exactly 5 alphanumeric characters long"
241   echo >&2 "Fix the cluster name in the 'local.params' file and re-run the provision script"
242   exit 1
243 fi
244
245 # Only used in single_host/single_name deploys
246 if [ "x${HOSTNAME_EXT}" = "x" ] ; then
247   HOSTNAME_EXT="${CLUSTER}.${DOMAIN}"
248 fi
249
250 if [ "${DUMP_CONFIG}" = "yes" ]; then
251   echo "The provision installer will just dump a config under ${DUMP_SALT_CONFIG_DIR} and exit"
252 else
253   # Install a few dependency packages
254   # First, let's figure out the OS we're working on
255   OS_ID=$(grep ^ID= /etc/os-release |cut -f 2 -d=  |cut -f 2 -d \")
256   echo "Detected distro: ${OS_ID}"
257
258   case ${OS_ID} in
259     "centos")
260       echo "WARNING! Disabling SELinux, see https://dev.arvados.org/issues/18019"
261       sed -i 's/SELINUX=enforcing/SELINUX=permissive' /etc/sysconfig/selinux
262       setenforce permissive
263       yum install -y  curl git jq
264       ;;
265     "debian"|"ubuntu")
266       DEBIAN_FRONTEND=noninteractive apt update
267       DEBIAN_FRONTEND=noninteractive apt install -y curl git jq
268       ;;
269   esac
270
271   if which salt-call; then
272     echo "Salt already installed"
273   else
274     curl -L https://bootstrap.saltstack.com -o /tmp/bootstrap_salt.sh
275     sh /tmp/bootstrap_salt.sh -XdfP -x python3
276     /bin/systemctl stop salt-minion.service
277     /bin/systemctl disable salt-minion.service
278   fi
279
280   # Set salt to masterless mode
281   cat > /etc/salt/minion << EOFSM
282 failhard: "True"
283
284 file_client: local
285 file_roots:
286   base:
287     - ${S_DIR}
288     - ${F_DIR}/*
289
290 pillar_roots:
291   base:
292     - ${P_DIR}
293 EOFSM
294 fi
295
296 mkdir -p ${S_DIR} ${F_DIR} ${P_DIR} ${T_DIR}
297
298 # Get the formula and dependencies
299 cd ${F_DIR} || exit 1
300 echo "Cloning formulas"
301 rm -rf ${F_DIR}/* || exit 1
302 git clone --quiet https://github.com/saltstack-formulas/docker-formula.git ${F_DIR}/docker
303 ( cd docker && git checkout --quiet tags/"${DOCKER_TAG}" -b "${DOCKER_TAG}" )
304
305 git clone --quiet https://github.com/saltstack-formulas/locale-formula.git ${F_DIR}/locale
306 ( cd locale && git checkout --quiet tags/"${LOCALE_TAG}" -b "${LOCALE_TAG}" )
307
308 git clone --quiet https://github.com/netmanagers/nginx-formula.git ${F_DIR}/nginx
309 ( cd nginx && git checkout --quiet tags/"${NGINX_TAG}" -b "${NGINX_TAG}" )
310
311 git clone --quiet https://github.com/saltstack-formulas/postgres-formula.git ${F_DIR}/postgres
312 ( cd postgres && git checkout --quiet tags/"${POSTGRES_TAG}" -b "${POSTGRES_TAG}" )
313
314 git clone --quiet https://github.com/saltstack-formulas/letsencrypt-formula.git ${F_DIR}/letsencrypt
315 ( cd letsencrypt && git checkout --quiet tags/"${LETSENCRYPT_TAG}" -b "${LETSENCRYPT_TAG}" )
316
317 git clone --quiet https://git.arvados.org/arvados-formula.git ${F_DIR}/arvados
318
319 # If we want to try a specific branch of the formula
320 if [ "x${BRANCH}" != "x" ]; then
321   ( cd ${F_DIR}/arvados && git checkout --quiet -t origin/"${BRANCH}" -b "${BRANCH}" )
322 elif [ "x${ARVADOS_TAG}" != "x" ]; then
323 ( cd ${F_DIR}/arvados && git checkout --quiet tags/"${ARVADOS_TAG}" -b "${ARVADOS_TAG}" )
324 fi
325
326 if [ "x${VAGRANT}" = "xyes" ]; then
327   EXTRA_STATES_DIR="/home/vagrant/${CONFIG_DIR}/states"
328   SOURCE_PILLARS_DIR="/home/vagrant/${CONFIG_DIR}/pillars"
329   SOURCE_TESTS_DIR="/home/vagrant/${TESTS_DIR}"
330 else
331   EXTRA_STATES_DIR="${SCRIPT_DIR}/${CONFIG_DIR}/states"
332   SOURCE_PILLARS_DIR="${SCRIPT_DIR}/${CONFIG_DIR}/pillars"
333   SOURCE_TESTS_DIR="${SCRIPT_DIR}/${TESTS_DIR}"
334 fi
335
336 SOURCE_STATES_DIR="${EXTRA_STATES_DIR}"
337
338 echo "Writing pillars and states"
339
340 # Replace variables (cluster,  domain, etc) in the pillars, states and tests
341 # to ease deployment for newcomers
342 if [ ! -d "${SOURCE_PILLARS_DIR}" ]; then
343   echo "${SOURCE_PILLARS_DIR} does not exist or is not a directory. Exiting."
344   exit 1
345 fi
346 for f in $(ls "${SOURCE_PILLARS_DIR}"/*); do
347   sed "s#__ANONYMOUS_USER_TOKEN__#${ANONYMOUS_USER_TOKEN}#g;
348        s#__BLOB_SIGNING_KEY__#${BLOB_SIGNING_KEY}#g;
349        s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
350        s#__CLUSTER__#${CLUSTER}#g;
351        s#__DOMAIN__#${DOMAIN}#g;
352        s#__HOSTNAME_EXT__#${HOSTNAME_EXT}#g;
353        s#__HOSTNAME_INT__#${HOSTNAME_INT}#g;
354        s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
355        s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g;
356        s#__INITIAL_USER__#${INITIAL_USER}#g;
357        s#__LE_AWS_REGION__#${LE_AWS_REGION}#g;
358        s#__LE_AWS_SECRET_ACCESS_KEY__#${LE_AWS_SECRET_ACCESS_KEY}#g;
359        s#__LE_AWS_ACCESS_KEY_ID__#${LE_AWS_ACCESS_KEY_ID}#g;
360        s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
361        s#__KEEPWEB_EXT_SSL_PORT__#${KEEPWEB_EXT_SSL_PORT}#g;
362        s#__KEEP_EXT_SSL_PORT__#${KEEP_EXT_SSL_PORT}#g;
363        s#__MANAGEMENT_TOKEN__#${MANAGEMENT_TOKEN}#g;
364        s#__RELEASE__#${RELEASE}#g;
365        s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g;
366        s#__VERSION__#${VERSION}#g;
367        s#__WEBSHELL_EXT_SSL_PORT__#${WEBSHELL_EXT_SSL_PORT}#g;
368        s#__WEBSOCKET_EXT_SSL_PORT__#${WEBSOCKET_EXT_SSL_PORT}#g;
369        s#__WORKBENCH1_EXT_SSL_PORT__#${WORKBENCH1_EXT_SSL_PORT}#g;
370        s#__WORKBENCH2_EXT_SSL_PORT__#${WORKBENCH2_EXT_SSL_PORT}#g;
371        s#__CLUSTER_INT_CIDR__#${CLUSTER_INT_CIDR}#g;
372        s#__CONTROLLER_INT_IP__#${CONTROLLER_INT_IP}#g;
373        s#__WEBSOCKET_INT_IP__#${WEBSOCKET_INT_IP}#g;
374        s#__KEEP_INT_IP__#${KEEP_INT_IP}#g;
375        s#__KEEPSTORE0_INT_IP__#${KEEPSTORE0_INT_IP}#g;
376        s#__KEEPSTORE1_INT_IP__#${KEEPSTORE1_INT_IP}#g;
377        s#__KEEPWEB_INT_IP__#${KEEPWEB_INT_IP}#g;
378        s#__WEBSHELL_INT_IP__#${WEBSHELL_INT_IP}#g;
379        s#__SHELL_INT_IP__#${SHELL_INT_IP}#g;
380        s#__WORKBENCH1_INT_IP__#${WORKBENCH1_INT_IP}#g;
381        s#__WORKBENCH2_INT_IP__#${WORKBENCH2_INT_IP}#g;
382        s#__DATABASE_INT_IP__#${DATABASE_INT_IP}#g;
383        s#__WORKBENCH_SECRET_KEY__#${WORKBENCH_SECRET_KEY}#g" \
384   "${f}" > "${P_DIR}"/$(basename "${f}")
385 done
386
387 if [ "x${TEST}" = "xyes" ] && [ ! -d "${SOURCE_TESTS_DIR}" ]; then
388   echo "You requested to run tests, but ${SOURCE_TESTS_DIR} does not exist or is not a directory. Exiting."
389   exit 1
390 fi
391 mkdir -p ${T_DIR}
392 # Replace cluster and domain name in the test files
393 for f in $(ls "${SOURCE_TESTS_DIR}"/*); do
394   sed "s#__CLUSTER__#${CLUSTER}#g;
395        s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
396        s#__DOMAIN__#${DOMAIN}#g;
397        s#__HOSTNAME_INT__#${HOSTNAME_INT}#g;
398        s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
399        s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g
400        s#__INITIAL_USER__#${INITIAL_USER}#g;
401        s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
402        s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g" \
403   "${f}" > ${T_DIR}/$(basename "${f}")
404 done
405 chmod 755 ${T_DIR}/run-test.sh
406
407 # Replace helper state files that differ from the formula's examples
408 if [ -d "${SOURCE_STATES_DIR}" ]; then
409   mkdir -p "${F_DIR}"/extra/extra
410
411   for f in $(ls "${SOURCE_STATES_DIR}"/*); do
412     sed "s#__ANONYMOUS_USER_TOKEN__#${ANONYMOUS_USER_TOKEN}#g;
413          s#__CLUSTER__#${CLUSTER}#g;
414          s#__BLOB_SIGNING_KEY__#${BLOB_SIGNING_KEY}#g;
415          s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
416          s#__DOMAIN__#${DOMAIN}#g;
417          s#__HOSTNAME_EXT__#${HOSTNAME_EXT}#g;
418          s#__HOSTNAME_INT__#${HOSTNAME_INT}#g;
419          s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
420          s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g;
421          s#__INITIAL_USER__#${INITIAL_USER}#g;
422          s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
423          s#__KEEPWEB_EXT_SSL_PORT__#${KEEPWEB_EXT_SSL_PORT}#g;
424          s#__KEEP_EXT_SSL_PORT__#${KEEP_EXT_SSL_PORT}#g;
425          s#__MANAGEMENT_TOKEN__#${MANAGEMENT_TOKEN}#g;
426          s#__RELEASE__#${RELEASE}#g;
427          s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g;
428          s#__VERSION__#${VERSION}#g;
429          s#__CLUSTER_INT_CIDR__#${CLUSTER_INT_CIDR}#g;
430          s#__CONTROLLER_INT_IP__#${CONTROLLER_INT_IP}#g;
431          s#__WEBSOCKET_INT_IP__#${WEBSOCKET_INT_IP}#g;
432          s#__KEEP_INT_IP__#${KEEP_INT_IP}#g;
433          s#__KEEPSTORE0_INT_IP__#${KEEPSTORE0_INT_IP}#g;
434          s#__KEEPSTORE1_INT_IP__#${KEEPSTORE1_INT_IP}#g;
435          s#__KEEPWEB_INT_IP__#${KEEPWEB_INT_IP}#g;
436          s#__WEBSHELL_INT_IP__#${WEBSHELL_INT_IP}#g;
437          s#__WORKBENCH1_INT_IP__#${WORKBENCH1_INT_IP}#g;
438          s#__WORKBENCH2_INT_IP__#${WORKBENCH2_INT_IP}#g;
439          s#__DATABASE_INT_IP__#${DATABASE_INT_IP}#g;
440          s#__WEBSHELL_EXT_SSL_PORT__#${WEBSHELL_EXT_SSL_PORT}#g;
441          s#__WEBSOCKET_EXT_SSL_PORT__#${WEBSOCKET_EXT_SSL_PORT}#g;
442          s#__WORKBENCH1_EXT_SSL_PORT__#${WORKBENCH1_EXT_SSL_PORT}#g;
443          s#__WORKBENCH2_EXT_SSL_PORT__#${WORKBENCH2_EXT_SSL_PORT}#g;
444          s#__WORKBENCH_SECRET_KEY__#${WORKBENCH_SECRET_KEY}#g" \
445     "${f}" > "${F_DIR}/extra/extra"/$(basename "${f}")
446   done
447 fi
448
449 # Now, we build the SALT states/pillars trees
450 # As we need to separate both states and pillars in case we want specific
451 # roles, we iterate on both at the same time
452
453 # States
454 cat > ${S_DIR}/top.sls << EOFTSLS
455 base:
456   '*':
457     - locale
458 EOFTSLS
459
460 # Pillars
461 cat > ${P_DIR}/top.sls << EOFPSLS
462 base:
463   '*':
464     - locale
465     - arvados
466 EOFPSLS
467
468 # States, extra states
469 if [ -d "${F_DIR}"/extra/extra ]; then
470   if [ "$DEV_MODE" = "yes" ]; then
471     # In dev mode, we create some snake oil certs that we'll
472     # use as CUSTOM_CERTS, so we don't skip the states file
473     SKIP_SNAKE_OIL="dont_snakeoil_certs"
474   else
475     SKIP_SNAKE_OIL="snakeoil_certs"
476   fi
477   for f in $(ls "${F_DIR}"/extra/extra/*.sls | grep -v ${SKIP_SNAKE_OIL}); do
478   echo "    - extra.$(basename ${f} | sed 's/.sls$//g')" >> ${S_DIR}/top.sls
479   done
480   # Use custom certs
481   if [ "x${USE_LETSENCRYPT}" != "xyes" ]; then
482     mkdir -p "${F_DIR}"/extra/extra/files
483   fi
484 fi
485
486 # If we want specific roles for a node, just add the desired states
487 # and its dependencies
488 if [ -z "${ROLES}" ]; then
489   # States
490   echo "    - nginx.passenger" >> ${S_DIR}/top.sls
491   # Currently, only available on config_examples/multi_host/aws
492   if [ "x${USE_LETSENCRYPT}" = "xyes" ]; then
493     if [ "x${USE_LETSENCRYPT_IAM_USER}" != "xyes" ]; then
494       grep -q "aws_credentials" ${S_DIR}/top.sls || echo "    - extra.aws_credentials" >> ${S_DIR}/top.sls
495     fi
496     grep -q "letsencrypt"     ${S_DIR}/top.sls || echo "    - letsencrypt" >> ${S_DIR}/top.sls
497   else
498     # Use custom certs
499     # Copy certs to formula extra/files
500     # In dev mode, the files will be created and put in the destination directory by the
501     # snakeoil_certs.sls state file
502     mkdir -p /srv/salt/certs
503     cp -rv ${CUSTOM_CERTS_DIR}/* /srv/salt/certs/
504     # We add the custom_certs state
505     grep -q "custom_certs"    ${S_DIR}/top.sls || echo "    - extra.custom_certs" >> ${S_DIR}/top.sls
506   fi
507
508   echo "    - postgres" >> ${S_DIR}/top.sls
509   echo "    - docker.software" >> ${S_DIR}/top.sls
510   echo "    - arvados" >> ${S_DIR}/top.sls
511
512   # Pillars
513   echo "    - docker" >> ${P_DIR}/top.sls
514   echo "    - nginx_api_configuration" >> ${P_DIR}/top.sls
515   echo "    - nginx_controller_configuration" >> ${P_DIR}/top.sls
516   echo "    - nginx_keepproxy_configuration" >> ${P_DIR}/top.sls
517   echo "    - nginx_keepweb_configuration" >> ${P_DIR}/top.sls
518   echo "    - nginx_passenger" >> ${P_DIR}/top.sls
519   echo "    - nginx_websocket_configuration" >> ${P_DIR}/top.sls
520   echo "    - nginx_webshell_configuration" >> ${P_DIR}/top.sls
521   echo "    - nginx_workbench2_configuration" >> ${P_DIR}/top.sls
522   echo "    - nginx_workbench_configuration" >> ${P_DIR}/top.sls
523   echo "    - postgresql" >> ${P_DIR}/top.sls
524
525   # Currently, only available on config_examples/multi_host/aws
526   if [ "x${USE_LETSENCRYPT}" = "xyes" ]; then
527     if [ "x${USE_LETSENCRYPT_IAM_USER}" != "xyes" ]; then
528       grep -q "aws_credentials" ${P_DIR}/top.sls || echo "    - aws_credentials" >> ${P_DIR}/top.sls
529     fi
530     grep -q "letsencrypt"     ${P_DIR}/top.sls || echo "    - letsencrypt" >> ${P_DIR}/top.sls
531
532     # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
533     for c in controller websocket workbench workbench2 webshell download collections keepproxy; do
534       sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${c}.${CLUSTER}.${DOMAIN}*/g;
535               s#__CERT_PEM__#/etc/letsencrypt/live/${c}.${CLUSTER}.${DOMAIN}/fullchain.pem#g;
536               s#__CERT_KEY__#/etc/letsencrypt/live/${c}.${CLUSTER}.${DOMAIN}/privkey.pem#g" \
537       ${P_DIR}/nginx_${c}_configuration.sls
538     done
539   else
540     # Use custom certs (either dev mode or prod)
541     grep -q "extra_custom_certs" ${P_DIR}/top.sls || echo "    - extra_custom_certs" >> ${P_DIR}/top.sls
542     # And add the certs in the custom_certs pillar
543     echo "extra_custom_certs_dir: /srv/salt/certs" > ${P_DIR}/extra_custom_certs.sls
544     echo "extra_custom_certs:" >> ${P_DIR}/extra_custom_certs.sls
545
546     for c in controller websocket workbench workbench2 webshell download collections keepproxy; do
547       grep -q ${c} ${P_DIR}/extra_custom_certs.sls || echo "  - ${c}" >> ${P_DIR}/extra_custom_certs.sls
548
549       # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
550       sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${c}.pem/g;
551               s#__CERT_PEM__#/etc/nginx/ssl/arvados-${c}.pem#g;
552               s#__CERT_KEY__#/etc/nginx/ssl/arvados-${c}.key#g" \
553       ${P_DIR}/nginx_${c}_configuration.sls
554     done
555   fi
556 else
557   # If we add individual roles, make sure we add the repo first
558   echo "    - arvados.repo" >> ${S_DIR}/top.sls
559   # We add the custom_certs state
560   grep -q "custom_certs"    ${S_DIR}/top.sls || echo "    - extra.custom_certs" >> ${S_DIR}/top.sls
561
562   # And we add the basic part for the certs pillar
563   if [ "x${USE_LETSENCRYPT}" != "xyes" ]; then
564     # And add the certs in the custom_certs pillar
565     echo "extra_custom_certs_dir: /srv/salt/certs" > ${P_DIR}/extra_custom_certs.sls
566     echo "extra_custom_certs:" >> ${P_DIR}/extra_custom_certs.sls
567     grep -q "extra_custom_certs" ${P_DIR}/top.sls || echo "    - extra_custom_certs" >> ${P_DIR}/top.sls
568   fi
569
570   for R in ${ROLES}; do
571     case "${R}" in
572       "database")
573         # States
574         echo "    - postgres" >> ${S_DIR}/top.sls
575         # Pillars
576         echo '    - postgresql' >> ${P_DIR}/top.sls
577       ;;
578       "api")
579         # States
580         # FIXME: https://dev.arvados.org/issues/17352
581         grep -q "postgres.client" ${S_DIR}/top.sls || echo "    - postgres.client" >> ${S_DIR}/top.sls
582         grep -q "nginx.passenger" ${S_DIR}/top.sls || echo "    - nginx.passenger" >> ${S_DIR}/top.sls
583         ### If we don't install and run LE before arvados-api-server, it fails and breaks everything
584         ### after it. So we add this here as we are, after all, sharing the host for api and controller
585         # Currently, only available on config_examples/multi_host/aws
586         if [ "x${USE_LETSENCRYPT}" = "xyes" ]; then
587           if [ "x${USE_LETSENCRYPT_IAM_USER}" != "xyes" ]; then
588             grep -q "aws_credentials" ${S_DIR}/top.sls || echo "    - aws_credentials" >> ${S_DIR}/top.sls
589           fi
590           grep -q "letsencrypt" ${S_DIR}/top.sls || echo "    - letsencrypt" >> ${S_DIR}/top.sls
591         else
592           # Use custom certs
593           copy_custom_cert ${CUSTOM_CERTS_DIR} controller
594           grep -q controller ${P_DIR}/extra_custom_certs.sls || echo "  - controller" >> ${P_DIR}/extra_custom_certs.sls
595         fi
596         grep -q "arvados.${R}" ${S_DIR}/top.sls    || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
597         # Pillars
598         grep -q "aws_credentials" ${P_DIR}/top.sls          || echo "    - aws_credentials" >> ${P_DIR}/top.sls
599         grep -q "docker" ${P_DIR}/top.sls                   || echo "    - docker" >> ${P_DIR}/top.sls
600         grep -q "postgresql" ${P_DIR}/top.sls               || echo "    - postgresql" >> ${P_DIR}/top.sls
601         grep -q "nginx_passenger" ${P_DIR}/top.sls          || echo "    - nginx_passenger" >> ${P_DIR}/top.sls
602         grep -q "nginx_${R}_configuration" ${P_DIR}/top.sls || echo "    - nginx_${R}_configuration" >> ${P_DIR}/top.sls
603       ;;
604       "controller" | "websocket" | "workbench" | "workbench2" | "webshell" | "keepweb" | "keepproxy")
605         # States
606         grep -q "nginx.passenger" ${S_DIR}/top.sls || echo "    - nginx.passenger" >> ${S_DIR}/top.sls
607         # Currently, only available on config_examples/multi_host/aws
608         if [ "x${USE_LETSENCRYPT}" = "xyes" ]; then
609           if [ "x${USE_LETSENCRYPT_IAM_USER}" != "xyes" ]; then
610             grep -q "aws_credentials" ${S_DIR}/top.sls || echo "    - aws_credentials" >> ${S_DIR}/top.sls
611           fi
612           grep -q "letsencrypt"     ${S_DIR}/top.sls || echo "    - letsencrypt" >> ${S_DIR}/top.sls
613         else
614           # Use custom certs, special case for keepweb
615           if [ ${R} = "keepweb" ]; then
616             copy_custom_cert ${CUSTOM_CERTS_DIR} download
617             copy_custom_cert ${CUSTOM_CERTS_DIR} collections
618           else
619             copy_custom_cert ${CUSTOM_CERTS_DIR} ${R}
620           fi
621         fi
622         # webshell role is just a nginx vhost, so it has no state
623         if [ "${R}" != "webshell" ]; then
624           grep -q "arvados.${R}" ${S_DIR}/top.sls || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
625         fi
626         # Pillars
627         grep -q "nginx_passenger" ${P_DIR}/top.sls          || echo "    - nginx_passenger" >> ${P_DIR}/top.sls
628         grep -q "nginx_${R}_configuration" ${P_DIR}/top.sls || echo "    - nginx_${R}_configuration" >> ${P_DIR}/top.sls
629         # Special case for keepweb
630         if [ ${R} = "keepweb" ]; then
631           grep -q "nginx_download_configuration" ${P_DIR}/top.sls || echo "    - nginx_download_configuration" >> ${P_DIR}/top.sls
632           grep -q "nginx_collections_configuration" ${P_DIR}/top.sls || echo "    - nginx_collections_configuration" >> ${P_DIR}/top.sls
633         fi
634
635         # Currently, only available on config_examples/multi_host/aws
636         if [ "x${USE_LETSENCRYPT}" = "xyes" ]; then
637           if [ "x${USE_LETSENCRYPT_IAM_USER}" != "xyes" ]; then
638             grep -q "aws_credentials" ${P_DIR}/top.sls || echo "    - aws_credentials" >> ${P_DIR}/top.sls
639           fi
640           grep -q "letsencrypt"     ${P_DIR}/top.sls || echo "    - letsencrypt" >> ${P_DIR}/top.sls
641           grep -q "letsencrypt_${R}_configuration" ${P_DIR}/top.sls || echo "    - letsencrypt_${R}_configuration" >> ${P_DIR}/top.sls
642
643           # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
644           # Special case for keepweb
645           if [ ${R} = "keepweb" ]; then
646             for kwsub in download collections; do
647               sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${kwsub}.${CLUSTER}.${DOMAIN}*/g;
648                       s#__CERT_PEM__#/etc/letsencrypt/live/${kwsub}.${CLUSTER}.${DOMAIN}/fullchain.pem#g;
649                       s#__CERT_KEY__#/etc/letsencrypt/live/${kwsub}.${CLUSTER}.${DOMAIN}/privkey.pem#g" \
650               ${P_DIR}/nginx_${kwsub}_configuration.sls
651             done
652           else
653             sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${R}.${CLUSTER}.${DOMAIN}*/g;
654                     s#__CERT_PEM__#/etc/letsencrypt/live/${R}.${CLUSTER}.${DOMAIN}/fullchain.pem#g;
655                     s#__CERT_KEY__#/etc/letsencrypt/live/${R}.${CLUSTER}.${DOMAIN}/privkey.pem#g" \
656             ${P_DIR}/nginx_${R}_configuration.sls
657           fi
658         else
659           # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
660           # Special case for keepweb
661           if [ ${R} = "keepweb" ]; then
662             for kwsub in download collections; do
663               sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${kwsub}.pem/g;
664                       s#__CERT_PEM__#/etc/nginx/ssl/arvados-${kwsub}.pem#g;
665                       s#__CERT_KEY__#/etc/nginx/ssl/arvados-${kwsub}.key#g" \
666               ${P_DIR}/nginx_${kwsub}_configuration.sls
667               grep -q ${kwsub} ${P_DIR}/extra_custom_certs.sls || echo "  - ${kwsub}" >> ${P_DIR}/extra_custom_certs.sls
668             done
669           else
670             sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${R}.pem/g;
671                     s#__CERT_PEM__#/etc/nginx/ssl/arvados-${R}.pem#g;
672                     s#__CERT_KEY__#/etc/nginx/ssl/arvados-${R}.key#g" \
673             ${P_DIR}/nginx_${R}_configuration.sls
674             grep -q ${R} ${P_DIR}/extra_custom_certs.sls || echo "  - ${R}" >> ${P_DIR}/extra_custom_certs.sls
675           fi
676         fi
677       ;;
678       "shell")
679         # States
680         grep -q "docker" ${S_DIR}/top.sls       || echo "    - docker.software" >> ${S_DIR}/top.sls
681         grep -q "arvados.${R}" ${S_DIR}/top.sls || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
682         # Pillars
683         grep -q "" ${P_DIR}/top.sls                             || echo "    - docker" >> ${P_DIR}/top.sls
684       ;;
685       "dispatcher")
686         # States
687         grep -q "docker" ${S_DIR}/top.sls       || echo "    - docker.software" >> ${S_DIR}/top.sls
688         grep -q "arvados.${R}" ${S_DIR}/top.sls || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
689         # Pillars
690         # ATM, no specific pillar needed
691       ;;
692       "keepstore")
693         # States
694         grep -q "arvados.${R}" ${S_DIR}/top.sls || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
695         # Pillars
696         # ATM, no specific pillar needed
697       ;;
698       *)
699         echo "Unknown role ${R}"
700         exit 1
701       ;;
702     esac
703   done
704 fi
705
706 if [ "${DUMP_CONFIG}" = "yes" ]; then
707   # We won't run the rest of the script because we're just dumping the config
708   exit 0
709 fi
710
711 # FIXME! #16992 Temporary fix for psql call in arvados-api-server
712 if [ -e /root/.psqlrc ]; then
713   if ! ( grep 'pset pager off' /root/.psqlrc ); then
714     RESTORE_PSQL="yes"
715     cp /root/.psqlrc /root/.psqlrc.provision.backup
716   fi
717 else
718   DELETE_PSQL="yes"
719 fi
720
721 echo '\pset pager off' >> /root/.psqlrc
722 # END FIXME! #16992 Temporary fix for psql call in arvados-api-server
723
724 # Now run the install
725 salt-call --local state.apply -l ${LOG_LEVEL}
726
727 # FIXME! #16992 Temporary fix for psql call in arvados-api-server
728 if [ "x${DELETE_PSQL}" = "xyes" ]; then
729   echo "Removing .psql file"
730   rm /root/.psqlrc
731 fi
732
733 if [ "x${RESTORE_PSQL}" = "xyes" ]; then
734   echo "Restoring .psql file"
735   mv -v /root/.psqlrc.provision.backup /root/.psqlrc
736 fi
737 # END FIXME! #16992 Temporary fix for psql call in arvados-api-server
738
739 # Leave a copy of the Arvados CA so the user can copy it where it's required
740 if [ "$DEV_MODE" = "yes" ]; then
741   echo "Copying the Arvados CA certificate to the installer dir, so you can import it"
742   # If running in a vagrant VM, also add default user to docker group
743   if [ "x${VAGRANT}" = "xyes" ]; then
744     cp /etc/ssl/certs/arvados-snakeoil-ca.pem /vagrant/${CLUSTER}.${DOMAIN}-arvados-snakeoil-ca.pem
745
746     echo "Adding the vagrant user to the docker group"
747     usermod -a -G docker vagrant
748   else
749     cp /etc/ssl/certs/arvados-snakeoil-ca.pem ${SCRIPT_DIR}/${CLUSTER}.${DOMAIN}-arvados-snakeoil-ca.pem
750   fi
751 fi
752
753 # Test that the installation finished correctly
754 if [ "x${TEST}" = "xyes" ]; then
755   cd ${T_DIR}
756   # If we use RVM, we need to run this with it, or most ruby commands will fail
757   RVM_EXEC=""
758   if [ -x /usr/local/rvm/bin/rvm-exec ]; then
759     RVM_EXEC="/usr/local/rvm/bin/rvm-exec"
760   fi
761   ${RVM_EXEC} ./run-test.sh
762 fi